//
//  ViewController.m
//  ChartWithGradientColor
//
//  Created by synclapn5656 on 15/12/15.
//  Copyright (c) 2015 Syncfusion Chart. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController
{
    NSMutableArray * _dataPoints;
    SFChart        * _chart;
}

- (void)viewDidLoad {
    
    
    [super viewDidLoad];
    
    [self load];
    
    
    // Do any additional setup after loading the view, typically from a nib.
}

-(NSMutableArray *) generateScatterDataPoints
{
    NSMutableArray *dataPoints = [[NSMutableArray alloc]init];
    SFChartDataPoint * numericPoints = [[SFChartDataPoint alloc]initWithXValue:@"2007" andYValue:@112.3];
    [dataPoints addObject:numericPoints];
    numericPoints = [[SFChartDataPoint alloc]initWithXValue:@"2008" andYValue:@142];
    [dataPoints addObject:numericPoints];
    numericPoints = [[SFChartDataPoint alloc]initWithXValue:@"2009" andYValue:@122.16];
    [dataPoints addObject:numericPoints];
    numericPoints = [[SFChartDataPoint alloc]initWithXValue:@"2010" andYValue:@132.1];
    [dataPoints addObject:numericPoints];
    numericPoints = [[SFChartDataPoint alloc]initWithXValue:@"2011" andYValue:@141.61];
    [dataPoints addObject:numericPoints];
    numericPoints = [[SFChartDataPoint alloc]initWithXValue:@"2012" andYValue:@212.05];
    [dataPoints addObject:numericPoints];
    numericPoints = [[SFChartDataPoint alloc]initWithXValue:@"2013" andYValue:@312.5];
    [dataPoints addObject:numericPoints];
    numericPoints = [[SFChartDataPoint alloc]initWithXValue:@"2014" andYValue:@112.21];
    [dataPoints addObject:numericPoints];
    numericPoints = [[SFChartDataPoint alloc]initWithXValue:@"2015" andYValue:@212.34];
    [dataPoints addObject:numericPoints];
    return dataPoints;
}


-(void)load
{
    _dataPoints                  = [self generateScatterDataPoints];
    _chart                       = [[SFChart alloc] init];
    _chart.title.edgeInsets      = UIEdgeInsetsMake(10, 0, 10, 0);
    
    //Primary Axis
    
    SFNumericalAxis * axis        = [[SFNumericalAxis alloc]init];
    axis.plotOffset              = 10;
    axis.showMajorGridLines      = false;
    axis.axisLineStyle.lineWidth = @0.5;
    axis.interval                = @2;
    axis.labelStyle.font         = [UIFont fontWithName:@"HelveticaNeue" size:12];
    _chart.primaryAxis            = axis;
    
    // Secondary Axis
    
    SFNumericalAxis * axis1        = [[SFNumericalAxis alloc]init];
    _chart.secondaryAxis           = axis1;
    axis1.edgeLabelsDrawingMode    = SFChartAxisEdgeLabelsDrawingModeShift;
    
    _chart.frame                      = self.view.frame;
    _chart.dataSource                 = self;
    [self.view addSubview:_chart];
    
}

-(NSInteger) numberOfSeriesInChart:(SFChart *)chart
{
    return 1;
}


-(SFSeries *) chart:(SFChart *)chart seriesAtIndex:(NSInteger)index
{
    SFAreaSeries * series     = [[SFAreaSeries alloc]init];
    series.dataMarker.showMarker = true;
    series.dataMarker.markerType = SFChartDataMarkerTypeCircle;
    series.dataMarker.markerHeight = 5;
    series.dataMarker.markerWidth = 5;
    series.dataMarker.markerBorderColor = [UIColor blackColor];
    series.dataMarker.markerColor = [[UIColor alloc] initWithRed:193.0/255 green:39.0/255 blue:45.0/255 alpha:1.0];
    return series;
}

-(NSInteger) chart:(SFChart *)chart numberOfDataPointsForSeriesAtIndex:(NSInteger)index
{
    return _dataPoints.count;
}

-(SFChartDataPoint *) chart:(SFChart *)chart dataPointAtIndex:(NSInteger)index forSeriesAtIndex:(NSInteger)seriesIndex{
    
    return _dataPoints[index];
}

-(void) viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    SFSeries * series = [_chart seriesAtIndex:0];
    
    
    CAGradientLayer *gradient = [ViewController gradient];
    gradient.frame = series.layerFrame;
    
    UIGraphicsBeginImageContext(gradient.frame.size);
    [gradient renderInContext:UIGraphicsGetCurrentContext()];
    UIImage * gradientImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    series.color = [[UIColor alloc] initWithPatternImage:gradientImage];
}


+ (CAGradientLayer*) gradient
{
    
    UIColor *colorOne = [UIColor redColor];
    UIColor *colorTwo = [UIColor yellowColor];
    UIColor *colorThree = [UIColor redColor];
    
    NSArray *colors = [NSArray arrayWithObjects:(id)colorOne.CGColor, colorTwo.CGColor,colorThree.CGColor, nil];
    NSNumber *stopOne = [NSNumber numberWithFloat:0.1];
    NSNumber *stopTwo = [NSNumber numberWithFloat:0.7];
    NSNumber *stopThree = [NSNumber numberWithFloat:1.0];
    
    NSArray *locations = [NSArray arrayWithObjects:stopOne, stopTwo,stopThree, nil];
    
    CAGradientLayer *headerLayer = [CAGradientLayer layer];
    headerLayer.colors = colors;
    headerLayer.locations = locations;
    
    return headerLayer;
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(BOOL) prefersStatusBarHidden
{
    return YES;
}

@end
